#include "system_class.h"


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR pScmdline, int iCmdshow)
{
	system_class* System;
	bool result;
	
	wchar_t path[MAX_PATH];
	HMODULE hmodule = GetModuleHandle(NULL);
	if (hmodule != NULL)
	{
		GetModuleFileName(hmodule, path, (sizeof(path) / sizeof(wchar_t)));
	}
	
	std::filesystem::path exePath(path);
	std::filesystem::path WFolder = exePath.parent_path();
	
	// Create the system object.
	System = new system_class;
	
	// initialize and run the system object.
	result = System->initialize();
	if (result)
	{
		Logger::Get().Log("System initialized", __FILE__, __LINE__, Logger::LogLevel::Initialize);
		System->send_path(path,WFolder);
		System->run();
	}
	
	// shutdown and release the system object.
	System->shutdown();
	delete System;
	System = 0;

	return 0;
}